{*******************************************************************************
  HiAsm stamp component builder v0.8 (autor - andrestudio <andrestudio@list.ru>)
  Component - BASS_VisLights
  Version - 1.2
  Autor - andrestudio
  E-mail - andrestudio@list.ru
  Create - , 11.  2018, 17:51:05
  Description:    4    BASS.dll
*******************************************************************************}

unit hiBASS_VisLights;

interface

uses Kol,Share,Debug,bass;

type TFFTData = array [0..512] of Single;

type

 THIBASS_VisLights = class(TDebug)
   private
     FFTData: TFFTData;
     FRed,FGreen,FYellow,FBlue,FGeneral: integer;
   public
   { Property }
     {   }
     _prop_SoundStream: ^cardinal;
   { Event points }
     _event_onRed: THI_Event;
     _event_onGreen: THI_Event;
     _event_onYellow: THI_Event;
     _event_onBlue: THI_Event;

   { Events }
     {     ( ) }
     procedure onRed;
     {     ( ) }
     procedure onGreen;
     {     ( ) }
     procedure onYellow;
     {     ( ) }
     procedure onBlue;

   { Methods }
     {         }
     procedure _work_doGetLight(var _Data: TData; Index: Word);
     {      +/- 100 }
     procedure _work_doLevelRed(var _Data: TData; Index: Word);
     {      +/- 100 }
     procedure _work_doLevelGreen(var _Data: TData; Index: Word);
     {      +/- 100 }
     procedure _work_doLevelYellow(var _Data: TData; Index: Word);
     {      +/- 100 }
     procedure _work_doLevelBlue(var _Data: TData; Index: Word);
     {      +/- 100 }
     procedure _work_doLevelGeneral(var _Data: TData; Index: Word);
     {     onRes       RGB }
     procedure GetLight(var onRes: integer; StartIdx,EndIdx,IdxRGB: integer; Yellow: boolean);
     {           }
     function MaxAmplitude(StartIdx,EndIdx: integer): integer;

  end;

implementation

const
  {          }
  START_RED = 0;
  END_RED = 0;
  START_GREEN = 31;
  END_GREEN = 36;
  START_YELLOW = 63;
  END_YELLOW = 68;
  START_BLUE = 127;
  END_BLUE = 132;

{$ifdef F_P}
function IntToByte(Value:Integer): Byte;
begin
  if Value < 0 then Result:=0
  else if Value > 255 then Result := 255
  else Result := Value;
end;
{$else}
function IntToByte(i: Integer): Byte;
asm
    or   eax, eax
    jns  @1        // > 0
    xor  eax, eax
    ret
@1: cmp  eax, 0FFh
    jbe  @2        // <= 255
    or  eax, 0FFh
@2:
end;
{$endif}

{      +/- 100 }
procedure THIBASS_VisLights._work_doLevelRed(var _Data: TData; Index: Word);
begin
  FRed := ToInteger(_Data);
end;

{      +/- 100 }
procedure THIBASS_VisLights._work_doLevelGreen;
begin
  FGreen := ToInteger(_Data);
end;

{      +/- 100 }
procedure THIBASS_VisLights._work_doLevelYellow;
begin
  FYellow := ToInteger(_Data);
end;

{      +/- 100 }
procedure THIBASS_VisLights._work_doLevelBlue;
begin
  FBlue := ToInteger(_Data);
end;

{      +/- 100 }
procedure THIBASS_VisLights._work_doLevelGeneral;
begin
  FGeneral := (ToInteger(_Data)*100);
end;


{           }
function THIBASS_VisLights.MaxAmplitude(StartIdx,EndIdx: integer): integer;
var
  i: integer;
  Val,tmp: single;
begin
  for i := StartIdx to EndIdx do
  begin
    tmp := FFTData[i];
    if tmp > Val then
    begin
      Val := tmp;
      Result := i;
    end;
  end;
end;

{     onRes       RGB }
procedure THIBASS_VisLights.GetLight;
var
  tmp,tmp1: integer;
  byteTmp: byte;
  OutColor: array[0..3] of Byte absolute tmp1;
  Val,Pos: single;
begin
  tmp1 := 0; tmp := 0;
  Val := FFTData[MaxAmplitude(StartIdx,EndIdx)];
  if Val < 0.0 then Val := - Val;
  Pos := Trunc(Val*(10000 + FGeneral));
  tmp := Trunc(Pos);
  case IdxRGB of
    0: tmp := tmp + FRed;
    1: tmp := tmp + FGreen;
    2: tmp := tmp + FBlue;
    3: tmp := tmp + FYellow;
  end;
  if tmp > 255 then tmp := 255;
  if tmp < 32  then tmp := 32;
  byteTmp := IntToByte(tmp);
  if (Yellow = False) then
    OutColor[IdxRGB] := byteTmp
  else
    begin OutColor[0] := byteTmp; OutColor[1] := byteTmp; end;
  tmp := tmp1;
  onRes := tmp;
end;


{         }
procedure THIBASS_VisLights._work_doGetLight;
var
  h: cardinal;
begin
  h := _prop_SoundStream^;
  if BASS_ChannelIsActive(h) <> BASS_ACTIVE_PLAYING then Exit;
  BASS_ChannelGetData(h, @FFTData, BASS_DATA_FFT1024 or BASS_DATA_FFT_NOWINDOW);
  onRed;
  onGreen;
  onYellow;
  onBlue;
end;

{     ( ) }
procedure THIBASS_VisLights.onRed;
var
  tmp: integer;
begin
  GetLight(tmp, START_RED, END_RED, 0, False);
  _hi_onEvent(_event_onRed, tmp);
  Applet.ProcessMessages;
end;

{     ( ) }
procedure THIBASS_VisLights.onGreen;
var
  tmp: integer;
begin
  GetLight(tmp, START_GREEN, END_GREEN, 1, False);
  _hi_onEvent(_event_onGreen,tmp);
  Applet.ProcessMessages;
end;

{     ( ) }
procedure THIBASS_VisLights.onYellow;
var
  tmp: integer;
begin
  GetLight(tmp, START_YELLOW, END_YELLOW, 3, True);
  _hi_onEvent(_event_onYellow, tmp);
  Applet.ProcessMessages;
end;

{     ( ) }
procedure THIBASS_VisLights.onBlue;
var
  tmp: integer;
begin
  GetLight(tmp, START_BLUE, END_BLUE, 2, False);
  _hi_onEvent(_event_onBlue, tmp);
  Applet.ProcessMessages;
end;


end.
